import CommandManager
import Hub
import pyadchpp as adchpp
from ScriptManager import ScriptBase
import ScriptManager
import autil
import os
import re

class Script(ScriptBase):

    execMatch = re.compile(r"({<(?:[^{])*>})")
    evalMatch = re.compile(r"({(?:[^{])*})")

    def __init__(self):
        self.motdFile = os.path.join(Hub.CfgDir , "motd.txt")
        self.motd = None
        self.motdModified = 0

        self.onConnect = autil.handleState(self.sendMOTD,adchpp.Entity.STATE_NORMAL)

    def unload(self):
        del(self.onConnect)

    def reload(self):
        del(self.onConnect)
        self.onConnect = autil.handleState(self.sendMOTD,adchpp.Entity.STATE_NORMAL)

    def loadMOTD(self):
        if os.path.exists(self.motdFile):
            motdFile = open(self.motdFile, 'r')
            self.motd = str(motdFile.read())
            self.motdModified = os.path.getmtime(self.motdFile)

    def sendMOTD(self, ent, oldState):
        if os.path.exists(self.motdFile):
            if self.motdModified != os.path.getmtime(self.motdFile):
                self.loadMOTD()


        msg = self.motd

        execs = re.findall(self.execMatch, msg)
        if execs:
            for index in xrange(len(execs)):
                param = ""
                try:
                    exec(execs[index][2:-2])
                except Exception as err:
                    autil.log(__name__, str(err))

                msg = msg.replace(execs[index], "", 1)

        evals = re.findall(self.evalMatch, msg)
        if evals:
            for index in xrange(len(evals)):
                param = ""
                try:
                    inter = eval(evals[index][1:-1])
                    param = inter
                except Exception as err:
                    autil.log(__name__, str(err))

                msg = msg.replace(evals[index], str(param), 1)
                

        if msg:
            autil.hub_reply(ent, msg)